'use client'

import { useLayoutEffect, useRef } from 'react';
import { useSearchParams } from 'next/navigation';

import comic_sans from '../../../../comic.ts';
import { message_style } from '../components/Input.css';

export default function Input() {
	const search_params = useSearchParams();
	const input_ref = useRef<HTMLParagraphElement>(null);

	function set_message(message: string) {
		const encoded = btoa(message);
		const new_url = `${window.location.protocol}//${window.location.host}${window.location.pathname}?e=${encoded}`;
		window.history.replaceState(null, '', new_url);
		input_ref.current!.style.height = "";
		input_ref.current!.style.height = `${input_ref.current!.scrollHeight}px`;
	}

	const message = search_params.get('e') ?
		atob(search_params.get('e')!) :
		(
			search_params.get('m')
			?? 'At the apex of the pyramid comes Big Brother. Big Brother is infallible and all-powerful. Every success, every achievement, every victory, every scientific discovery, all knowledge, all wisdom, all happiness, all virtue, are held to issue directly from his leadership and inspiration.'
		);

	useLayoutEffect(() => {
		set_message(message);
	});

	return (
		<textarea
			ref={input_ref}
			className={message_style}
			type="text"
			rows="1"
			onInput={() => set_message(input_ref.current!.textContent ?? '')}
			defaultValue={message}
		/>
	);
}
